//----
string Indicator_Name = "ind1";
int Objs = 0;
//----
#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Yellow
#property indicator_color4 Pink
//----
int Bars.Count = 0;

extern int Min = 13;
extern int Midle = 21;
extern int Max = 34;
extern int PeriodEMA = 3;
//---- 
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ma[];
double ma2[];
double TempBuffer1[];
double TempBuffer2[];
int method_ma = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
IndicatorShortName(Indicator_Name);
int cur = 0;
int st = 23;
//-------------------------------------------
int width = 2;

SetIndexStyle(0, DRAW_LINE);
SetIndexBuffer(0, ExtMapBuffer1);
SetIndexStyle(1, DRAW_LINE);
SetIndexBuffer(1, ExtMapBuffer2);
SetIndexBuffer(2, ma);
SetIndexStyle(2, DRAW_LINE);
SetIndexBuffer(3, ma2);
SetIndexStyle(3, DRAW_LINE);
SetIndexBuffer(4, TempBuffer1);
SetIndexStyle(4, DRAW_NONE);
SetIndexBuffer(5, TempBuffer2);
SetIndexStyle(5, DRAW_NONE);

ArraySetAsSeries(ExtMapBuffer1,true);
ArraySetAsSeries(ExtMapBuffer2,true);

//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
int limit;
if (IndicatorCounted()<0) return(-1);
limit=Bars-IndicatorCounted();
if (Bars.Count>0 && limit>Bars.Count)
limit=Bars.Count;
int i = limit;
//----
while(i >= 0)
{
double High1 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, Min,i+1));
double High2 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, Midle,i+1));
double High3 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, Max,i+1));
TempBuffer1[i] = ((High[i]-High1)+(High[i]-High2)+(High[i]-High3));
double Low1 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, Min, i+1));
double Low2 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, Midle, i+1));
double Low3 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, Max, i+1));
TempBuffer2[i] = ((Low1-Low[i])+(Low2-Low[i])+(Low3-Low[i]));
i--;
}
//----  
for( i = 0; i < limit; i++)
{
if (PeriodEMA > 0 )
{
ExtMapBuffer1[i] = -iMAOnArray(TempBuffer1,Bars,PeriodEMA,0,MODE_EMA,i);
ExtMapBuffer2[i] = -iMAOnArray(TempBuffer2,Bars,PeriodEMA,0,MODE_EMA,i);
}
else
{
ExtMapBuffer1[i] = TempBuffer1[i];
ExtMapBuffer2[i] = TempBuffer2[i];
}
}
//====================================================================
//--------------------------------------------------------------------
//  
for(i = 0; i < limit; i++)
{
ma[i]=iMAOnArray(ExtMapBuffer1,0,8,0,method_ma,i);
ma2[i]=iMAOnArray(ExtMapBuffer2,0,8,0,method_ma,i);
}
//====================================================================
//----
return(0);
}